
;;; The type of the array is not propagated in the following, but is
;;; if simplified.
(defun tst (array)
  (cond ((typep array '(simple-array double-float))
	 (let ((I 0))
	   (tagbody
	    next-loop
	      (when (>= i 10)
		(go end-loop))
	      (setq I (1+ I))
	      (go next-loop)
	    end-loop))
	 array)
	(t 'xx)))

;;; Type is correctly propagated in the following.
(defun negate-matrix (a)
  (declare (optimize speed (safety 0)))
  (etypecase a
    ((simple-array double-float)
     (setf (row-major-aref a 0) (- (row-major-aref a 10))))))
